﻿//DESCRIPTION:Magic Footnote Option Copier
// A Jongware Script 19-Aug-2010

myDialog = app.dialogs.add ({name:"Copy [FnOpt] to Other Documents",canCancel:true});

doclist = [];
uselist = [];
for (i=0; i<app.documents.length; i++)
	if (app.documents[i] != app.activeDocument)
	{
		doclist.push (app.documents[i].name);
		uselist.push (app.documents[i]);
	}

with (myDialog)
{
	with (dialogColumns.add())
	{
		with (dialogRows.add())
			staticTexts.add ({staticLabel:"Copy From: "+app.activeDocument.name});
		with (dialogRows.add())
		{
			staticTexts.add ({staticLabel:"Copy To"});
			listbox = dropdowns.add ({stringList:doclist, selectedIndex:0});
		}
		with (dialogRows.add())
			allofem = checkboxControls.add({staticLabel:"All of the above", checkedState:false});
	}
}
if (!myDialog.show())
{
	myDialog.destroy();
	exit(0);
}

err = [];
if (allofem.checkedState == true)
{
	for (i=0; i<uselist.length; i++)
		copyFnOpt(app.activeDocument, uselist[i], err);
} else
	copyFnOpt(app.activeDocument, uselist[listbox.selectedIndex], err);

if (err.length)
	alert ("The following items could not be set:\r"+err.join ("\r"));

function copyFnOpt (source,dest, errorsHere)
{
	var a;
	for (a in app.activeDocument.footnoteOptions.properties)
	{
		switch (a)
		{
			case "parent": break;
			case "footnoteMarkerStyle":
				if (source.footnoteOptions.footnoteMarkerStyle == null)
					dest.footnoteOptions.footnoteMarkerStyle = null;
				else
					try {
						dest.footnoteOptions.footnoteMarkerStyle = dest.characterStyles.item(source.footnoteOptions.footnoteMarkerStyle.name);
					} catch (_)
					{
						errorsHere.push (a+" to "+source.footnoteOptions.footnoteMarkerStyle.name+" in "+dest.name);
					}
				break;
			case "footnoteTextStyle":
				try {
					dest.footnoteOptions.footnoteTextStyle = dest.paragraphStyles.item(source.footnoteOptions.footnoteTextStyle.name);
				} catch (_)
				{
					errorsHere.push (a+" to "+source.footnoteOptions.footnoteTextStyle.name+" in "+dest.name);
				}
				break;
			case "ruleType":
			case "continuingRuleType":
				try {
					dest.footnoteOptions[a] = dest.strokeStyles.item(source.footnoteOptions[a].name);
				} catch (_)
				{
					errorsHere.push (a+" to "+source.footnoteOptions[a].name+" in "+dest.name);
				}
				break;
			case "ruleColor": case "ruleGapColor":
			case "continuingRuleColor": case "continuingRuleGapColor":
				try {
					dest.footnoteOptions[a] = dest.swatches.item(source.footnoteOptions[a].name);
				} catch (_)
				{
					try {
						dest.footnoteOptions[a] = dest.swatches.item("["+source.footnoteOptions[a].name+"]");
					} catch (_)
					{
						errorsHere.push (a+" to "+source.footnoteOptions[a].name+" in "+dest.name);
					}
				}
				break;
			default:
				try {
					dest.footnoteOptions[a] = source.footnoteOptions[a];
				} catch (_)
				{
					errorsHere.push(a);
				}
		}
	}
}
